const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const payments = sequelize.define(
    'payments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

payment_kind: {
        type: DataTypes.ENUM,
      
      

        values: [

"application_fee",


"monthly_tuition",


"field_trip",


"special_trip",


"end_of_summer_trip"

        ],

      },

amount: {
        type: DataTypes.DECIMAL,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"paid",


"failed",


"refunded",


"waived"

        ],

      },

method: {
        type: DataTypes.ENUM,
      
      

        values: [

"cash",


"check",


"card",


"online"

        ],

      },

reference_code: {
        type: DataTypes.TEXT,
      
      

      },

due_datetime: {
        type: DataTypes.DATE,
      
      

      },

paid_datetime: {
        type: DataTypes.DATE,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  payments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.payments.belongsTo(db.enrollments, {
      as: 'enrollment',
      foreignKey: {
        name: 'enrollmentId',
      },
      constraints: false,
    });




    db.payments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.payments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return payments;
};


